#include <stdio.h>

struct status_old {
   int             active;
   unsigned int    wait, count;
   unsigned int    number, request, answer;
   unsigned char   tourn;       /* Tournament mode? */
   /* These stats only updated during tournament mode */
   unsigned int    armsbomb, planets, kills, losses, time;
   unsigned long   timeprod;
   int             gameup;
#ifdef BASEPRACTICE
   double          dami, damr;  /* damage inflicted, damage repaired */
#endif
} old;

struct status_new {
   int             active;
   unsigned int    wait, count;
   unsigned int    number, request, answer;
   unsigned char   tourn;       /* Tournament mode? */
   /* These stats only updated during tournament mode */
   unsigned int    armsbomb, planets, kills, losses, time;
   double	   timeprod;
   int             gameup;
#ifdef BASEPRACTICE
   double          dami, damr;  /* damage inflicted, damage repaired */
#endif
} new;

main(argc, argv)

   int	argc;
   char	**argv;
{
   FILE	*fi, *fo;
   char	buf[80];

   if(argc != 2) {
      fprintf(stderr, "%s <global>\n", argv[0]);
      exit(0);
   }
   fi = fopen(argv[1], "r");
   if(!fread(&old, sizeof(old), 1, fi)){
      perror(argv[1]);
      exit(1);
   }

   printf("current timeprod: %d\n", old.timeprod);

   new.active = old.active;
   new.wait = old.wait;
   new.count = old.count;
   new.number = old.number;
   new.request = old.request;
   new.answer = old.answer;
   new.tourn = old.tourn;
   new.armsbomb = old.armsbomb;
   if(new.armsbomb < 10)
      new.armsbomb = 10;
   new.planets = old.planets;
   if(new.planets < 10)
      new.planets = 10;
   new.kills = old.kills;
   if(new.kills < 10)
      new.kills = 10;
   new.losses = old.losses;
   if(new.losses < 10)
      new.losses = 10;
   new.time = old.time;
   if(new.time < 10)
      new.time = 10;

   printf("new timeprod? "); fflush(stdout);
   gets(buf);
   sscanf(buf, "%lf", &new.timeprod);
   printf("new timeprod = %f\n", new.timeprod);

   new.gameup = old.gameup;
#ifdef BASEPRACTICE
   new.dami = old.dami;
   new.damr = old.damr;
#endif

   fo = fopen("NEW.global", "w");
   if(!fo) { perror("NEW.global"); exit(1); }
   if(!fwrite(&new, sizeof(new), 1, fo)){
      perror("NEW.global");
      exit(1);
   }
   printf("output is NEW.global\n");
}
