/*
 * defs.h
 */
#include "copyright.h"

#ifndef TRUE			/* OK, what include file are these in? */
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

/* max length of file names including path allowed for system defaults files */
#define MAXFNLEN		128

#define MAXPLAYER 20
#define TESTERS 4		/* Priveledged slots for robots and game
				 * 'testers' */
#define MAXPLANETS 40
#define MAXTORP 8		/* was 8 */
#define MAXPLASMA 1

#ifndef PKEY
#define PKEY 130
#endif

#define WINSIDE 500		/* Size of strategic and tactical windows */
#define BORDER 4		/* border width for option windows */
#define PSEUDOSIZE 16
#define CLOAK_PHASES 7		/* number of drawing phases in a cloak
				 * engage/disengage */
#define NUMRANKS 9

/* These are configuration definitions */

/* only other value technically supported is 200000 which messes up
   plfight slightly */
#define UPDATE 100000		/* Update time is 100000 micro-seconds */
#define UPDATE_NORM     	(UPDATE/100000)

#define GWIDTH 100000		/* galaxy is 100000 spaces on a side */
#define WARP1 20*UPDATE_NORM	/* warp one will move 20 spaces per update */
#define SCALE 40		/* Window will be one pixel for 20 spaces */
#define EXPDIST 350		/* At this range a torp will explode */
#define DAMDIST 2000		/* At this range a torp does damage */
#define SHIPDAMDIST 3000	/* At this range, an exploding ship does
				 * damage */
#define PLASDAMDIST 2500	/* At this range, a plasma does damage */
#define DETDIST 1800		/* was 1600 -- At this range a torp can be
				 * detonated */
#define PHASEDIST 6000		/* At this range a player can do damage with
				 * phasers */
#define ENTORBDIST 900		/* At this range a player can orbit a planet */
#define ORBDIST 800		/* A player will orbit at this radius */
#define ORBSPEED 2		/* This is the fastest a person can go into
				 * orbit */
#define PFIREDIST 1500		/* At this range a planet will shoot at a
				 * player */

#define AUTOQUIT 60		/* auto logout in 60 secs */
#define VACANT -1		/* indicates vacant port on a starbase */
#define DOCKDIST 600
#define DOCKSPEED 2		/* If base is moving, there will be some
				 * finesse involved to dock */
#define NUMPORTS 4
#define SBFUELMIN 10000		/* If starbase's fuel is less than this, it
				 * will not refuel docked vessels */
#define TRACTDIST   6000	/* maximum effective tractor beam range */
#define TRACTEHEAT  5		/* ammount tractor beams heat engines */
#define TRACTCOST   20		/* fuel cost of activated tractor beam */

/* These are memory sections */
#define PLAYER 1
#define MAXMESSAGE 50
#define MAXREVIEWMESSAGE 20

#define rosette(x)   ((((x) + 8) / 16) & 15)
/* #define rosette(x)   ((((x) + 256/VIEWS/2) / (256/VIEWS) + VIEWS) % VIEWS) */
/* (((x + 8) / 16 + 16)  %  16)  */

/* These are the teams */
/*
 * Note that I used bit types for these mostly for messages and war status.
 * This was probably a mistake.  It meant that Ed had to add the 'remap' area
 * to map these (which are used throughout the code as the proper team
 * variable) into a nice four team deep array for his color stuff.  Oh well.
 */
#define NOBODY 0x0
#define FED 0x1
#define ROM 0x2
#define KLI 0x4
#define ORI 0x8
#define ALLTEAM (FED|ROM|KLI|ORI)
#define MAXTEAM (ORI)
#define NUMTEAM 4
/*
 * * These are random configuration variables
 */
#ifndef TWO_RACE
#define VICTORY 3       /* Number of systems needed to conquer the galaxy */
#else
#define VICTORY 2       /* 2-Race Genocide, isae */
#endif

#define WARNTIME 30		/* Number of updates to have a warning on the
				 * screen */
#define MESSTIME 30		/* Number of updates to have a message on the
				 * screen */

#define BUILD_SB_TIME   30      /* Minutes to rebuild an SB 4/15/92 TC */
#define MIN_COUP_TIME   30      /* Min/max minutes before a geno'ed race */
#define MAX_COUP_TIME   60      /* can reenter and coup (random) 4/15/92 TC */

#define TARG_PLAYER	0x1	/* Flags for gettarget */
#define TARG_PLANET	0x2
#define TARG_CLOAK	0x4	/* Include cloaked ships in search */
#define TARG_SELF	0x8

#define TOP10FILENAME   ".top10"
#define GLOBAL          ".global"
#define SCORES          ".scores"
#define PLFILE          ".planets"
#define MOTD            ".motd"
#define MOTD_BITMAPS    ".motd_bitmaps"
#define DAEMON          "daemonII"
#define ROBOT           "robotII"
#ifdef SNAKEPATROL
#define SNAKEF		"snake"
#endif
#ifdef BIRD
#define BIRDF		"bird"
#endif
#if BORG
#define BORG_BOT	"borg"
#endif
#define LOGFILENAME     "logfile"
#define PLAYERFILE      ".players"		/* active */
#define PLAYERFILE_DB   ".players.db"		/* all players */
#define CONQFILE	".conquer"
#define SYSDEF_FILE     ".sysdef"
#define SERVER_FILE	".server"
#define NOTIFYFILE      ".notify"
#define BANNED_FILE     ".banned"
#define BYPASS_FILE     ".bypass"
#define SLOTSCUM_FILE	".slotscum"
#define LOGGER		"logmes"
#define MESGLOG		"mesg.LOG"	/* for all messages */
#define GODLOG		"god.LOG"	/* for messages to god */
#define GAMEDOWN_F	".down_mesg"

#ifdef BASEPRACTICE
#define BASEP		"basep"
#endif

#ifdef ORGANIAN
#define ORGANIANP	"organian"
#endif

#define MAKEMOTD	"./motd/makemotd"

#ifdef FEATURE
#define FEATURE_FILE	"./.feature"
#endif

/* Other stuff that Ed added */

#define ABS(a)			/* abs(a) */ (((a) < 0) ? -(a) : (a))
#ifndef MAX
#define MAX(a,b)		((a) > (b) ? (a) : (b))
#endif
#ifndef MIN
#define MIN(a,b)		((a) < (b) ? (a) : (b))
#endif

#define myPlasmaTorp(t)		(me->p_no == (t)->pt_owner)
#define myTorp(t)		(me->p_no == (t)->t_owner)
#define friendlyPlasmaTorp(t)	((!(me->p_team & (t)->pt_war)) || (myPlasmaTorp(t)))
#define friendlyTorp(t)		(((!(me->p_team & (t)->t_war)) && \
				  (!(t->t_team & (me->p_swar | me->p_hostile)))) || \
				 (myTorp(t)))
#define myPhaser(p)		(&phasers[me->p_no] == (p))
#define friendlyPhaser(p)	(me->p_team == players[(p) - phasers].p_team)
#define myPlayer(p)		(me == (p))
#define myPlanet(p)		(me->p_team == (p)->pl_owner)
#define friendlyPlayer(p)	((!(me->p_team & \
				    ((p)->p_swar | (p)->p_hostile))) && \
				 (!((p)->p_team & \
				    (me->p_swar | me->p_hostile))))
#define isAlive(p)		((p)->p_status == PALIVE)
#define friendlyPlanet(p)	((p)->pl_info & me->p_team && \
				 !((p)->pl_owner & (me->p_swar | me->p_hostile)))

#define torpColor(t)		\
  (myTorp(t) ? myColor : shipCol[remap[players[(t)->t_owner].p_team]])
#define plasmatorpColor(t)		\
  (myPlasmaTorp(t) ? myColor : shipCol[remap[players[(t)->pt_owner].p_team]])
#define phaserColor(p)		\
  (myPhaser(p) ? myColor : shipCol[remap[players[(p) - phasers].p_team]])
/*
 * Cloaking phase (and not the cloaking flag) is the factor in determining
 * the color of the ship.  Color 0 is white (same as 'myColor' used to be).
 */
#define playerColor(p)		\
  (myPlayer(p) ? 		\
   (cloak_pixels[0][me->p_cloakphase])	\
   : (cloak_pixels[remap[(p)->p_team]][(p)->p_cloakphase]))
#define planetColor(p)		\
  (((p)->pl_info & me->p_team) ? shipCol[remap[(p)->pl_owner]] : unColor)

#define planetFont(p)		\
  (myPlanet(p) ? bfont : friendlyPlanet(p) ? ifont : dfont)
#define shipFont(p)		\
  (myPlayer(p) ? bfont : friendlyPlayer(p) ? ifont : dfont)
#define bombingRating(p)	\
  ((double) (p)->p_stats.st_tarmsbomb * status->timeprod / \
   ((double) (p)->p_stats.st_tticks * status->armsbomb))
#define planetRating(p)		\
  ((double) (p)->p_stats.st_tplanets * status->timeprod / \
   ((double) (p)->p_stats.st_tticks * status->planets))
#define offenseRating(p)	\
  ((double) (p)->p_stats.st_tkills * status->timeprod / \
   ((double) (p)->p_stats.st_tticks * status->kills))
#define defenseRating(p)	\
  ((double) (p)->p_stats.st_tticks * status->losses / \
   ((p)->p_stats.st_tlosses!=0 ? \
    ((double) (p)->p_stats.st_tlosses * status->timeprod) : \
    (status->timeprod)))

#ifdef BASEPRACTICE

#define TRAD_IMPORTANCE				1.0

#define damInflictedRating(p)	\
        ((p)->p_stats.st_dami * status->timeprod /      \
         ((double)(p)->p_stats.st_tticks * status->dami))
#define damRepairedRating(p)	\
        ((p)->p_stats.st_damr * status->timeprod /      \
         ((double)(p)->p_stats.st_tticks * status->damr))

#define sbRateTrad(p)       ((double) (p)->p_stats.st_tkills / \
	((p)->p_stats.st_tlosses + 2.0 + (double)((p)->p_stats.st_tticks/10.) / 14400))

#define sbRateTradNorm(p)    (sbRateTrad(p)/ ((double) status->kills /\
           (status->losses + 2.0 + (double)(status->timeprod/10.)/14400)))

#define sbThirdRating(p)     ((damInflictedRating(p)/TRAD_IMPORTANCE) * sbRateTradNorm(p))
#endif

/*
 * This macro allows us to time things based upon the SIGALRM signal. Given a
 * number of 1/5 seconds, it will return the number of SIGALRMs we will
 * receive in that period.
 */
#define efticks(x) ((x)*200000/timerDelay)

/*
 * UDP control stuff
 */
#ifdef GATEWAY
#define UDP_NUMOPTS    11
#define UDP_GW         UDP_NUMOPTS-1
#else
#define UDP_NUMOPTS    10
#endif
#define UDP_CURRENT     0
#define UDP_STATUS      1
#define UDP_DROPPED     2
#define UDP_SEQUENCE    3
#define UDP_SEND        4
#define UDP_RECV        5
#define UDP_DEBUG       6
#define UDP_FORCE_RESET 7
#define UDP_UPDATE_ALL  8
#define UDP_DONE        9
#define COMM_TCP        0
#define COMM_UDP        1
#define COMM_VERIFY     2
#define COMM_UPDATE     3
#define COMM_MODE       4	/* put this one last */
#define SWITCH_TCP_OK   0
#define SWITCH_UDP_OK   1
#define SWITCH_DENIED   2
#define SWITCH_VERIFY   3
#define CONNMODE_PORT   0
#define CONNMODE_PACKET 1
#define STAT_CONNECTED  0
#define STAT_SWITCH_UDP 1
#define STAT_SWITCH_TCP 2
#define STAT_VERIFY_UDP 3
#define MODE_TCP        0
#define MODE_SIMPLE     1
#define MODE_FAT        2
#define MODE_DOUBLE     3

#define UDP_RECENT_INTR 300
#define UDP_UPDATE_WAIT 5	/* 5 second wait */

/* server version of UDPDIAG */
#define UDPDIAG(x)      if (udpAllowed > 1) { printf("UDP: "); printf x; fflush(stdout); }
#define V_UDPDIAG(x)    if (udpAllowed > 2) { printf("UDP: "); printf x; fflush(stdout); }

/* was defined in the daemon but we'd like to use it elsewhere */
#define GHOSTTIME       (30 * 1000000 / UPDATE)	/* 30 secs */

#if 0
#ifdef SYSV
#define signal(a, b)	sigset(a,b)
#endif
#endif

#define RESERVED_SIZE	16

#ifdef RSA
#define RSA_KEY_FILE	".reserved"
#define RSA_VERSION	"RSA v2.0 SERVER"
#endif

#define KEY_SIZE	32
#define MSG_LEN		80
#define NAME_LEN	16
#define KEYMAP_LEN	96

#ifdef CHAIN_REACTION
#define NODET (-1) /* isae - chain reaction case */
#endif

#ifdef MATH_ERROR_CHECK

#   define MATH_ERR_CHECK(v)		\
   {					\
      extern int errno;			\
      if(errno == 33){ /* EDOM */	\
	 char      buf[80];		\
	 sprintf(buf, "%s:%d: %d", __FILE__, __LINE__, v);	\
	 perror(buf);			\
      }					\
   }
#else
#   define MATH_ERR_CHECK(v)	/* nothing */
#endif


#ifdef SHORT_PACKETS
#if WINSIDE > 500
xyzzy		/* generator compiler error? */
#endif
#define TEXTE 0
#define PHASER_HIT_TEXT 1
#define BOMB_INEFFECTIVE 2
#define BOMB_TEXT 3
#define BEAMUP_TEXT 4
#define BEAMUP2_TEXT 5
#define BEAMUPSTARBASE_TEXT 6
#define BEAMDOWNSTARBASE_TEXT 7
#define BEAMDOWNPLANET_TEXT 8
#define SBREPORT 9
#define ONEARG_TEXT 10
#define BEAM_D_PLANET_TEXT 11
#define ARGUMENTS 12
#define BEAM_U_TEXT 13
#define LOCKPLANET_TEXT 14
#define LOCKPLAYER_TEXT 15
#define SBRANK_TEXT 16
#define SBDOCKREFUSE_TEXT 17
#define SBDOCKDENIED_TEXT 18
#define SBLOCKSTRANGER 19
#define SBLOCKMYTEAM 20
/*      Daemon messages */
#define DMKILL 21
#define KILLARGS 22
#define DMKILLP 23
#define DMBOMB 24
#define DMDEST 25
#define DMTAKE 26
#define DGHOSTKILL 27
/*      INL     messages                */
#define INLDMKILLP 28
#define INLDMKILL 29    /* Because of shiptypes */
#define INLDRESUME 30
#define INLDTEXTE 31
/* Variable warning stuff */
#define STEXTE 32               /* static text that the server needs to send to
the client first */
#define SHORT_WARNING 33 /* like CP_S_MESSAGE */
#define STEXTE_STRING 34
#define KILLARGS2 35

/* Warning flags , used in socket.c */
#define SVALID    253   /* Mark server messages as valid to send over SP_S_MESSA
GE */
#define SINVALID 254    /* Mark server Message as invalid to send over SP_S_MESS
AGE */
#define DINVALID 255    /* Mark daemon ( GOD) Message as invalid to send over SP
_S_WARNING */
#endif	/* SHORT_PACKETS */

#define timeprod_int()	(int)(status->timeprod/10.)

#define BITMAP_MOTD	1

#ifdef SYSV
#define UPTIME		"/usr/bin/uptime"
#else
#define UPTIME		"/usr/ubc/uptime"
#endif

#ifdef USE_EROBOT
#define EROBOT		"erobot"
#endif
